%{!?ksrc:   %define ksrcprv 0}
%{?ksrc:    %define ksrcprv 1}
%{!?kernel: %define kernel  %(uname -r)}
%{!?ksrc:   %define ksrc    %(bash %{SOURCE2} srcdir -u %{kernel} -p %{_target_cpu} 2>/dev/null)}

%define kmh() bash %{SOURCE2} %* -u %{kernel} -p %{_target_cpu} -s %{ksrc} 2>/dev/null

%if "%{kernel}" >= "2.5"
  %define k26 1
%else
  %define k26 0
%endif

Name:           kernel-module-thinkpad
Version:        5.0
Release:        0.fdr.4.rh90
Epoch:          0
Summary:        IBM ThinkPad support kernel modules

License:        GPL
Group:          System Environment/Kernel
URL:            http://tpctl.sourceforge.net/
Source0:        http://download.sourceforge.net/tpctl/thinkpad_5.0.tar.gz
Source1:        %{name}.makedev
Source2:        %{name}-kmodhelper
Patch0:         %{name}-rpm.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  i586 i686
BuildRequires:  bash, %{__perl}, MAKEDEV
%if ! %{ksrcprv}
BuildRequires:  kernel-source = 0:%(%kmh -- verrel)
%endif

%description
IBM ThinkPad support kernel modules.

The following rpmbuild options can be used to build this package
for a specific kernel:
--define "kernel <uname -r>"
  Specify the `uname -r` string of the target kernel, for example:
  "kernel 2.4.20-5smp".  The default is `uname -r` for the running kernel.
--define "ksrc <sourcetree>"
  Specify the kernel source directory, for example:
  "ksrc /lib/modules/2.4.20-5smp/build".  The default is
  resolved from <kernel>. You need to define ksrc if you
  try to build against a custom kernel.
--target <arch>
  Build for the given architecture instead of the default.

%package        %{kernel}
Summary:        %{summary}
Group:          System Environment/Kernel
Provides:       kernel-module
Provides:       %{name} = %{epoch}:%{version}-%{release}
Obsoletes:      kernel-mod-thinkpad
Requires(pre):  modutils
%if 0%(%kmh -- rhkernel)
Requires:       /boot/vmlinuz-%{kernel}
%endif

%description    %{kernel}
IBM ThinkPad support kernel modules.  See the end of the Installation
section in %{_docdir}/%{name}-%{kernel}-%{version}/README
for instructions how to enable the modules.


%prep
%setup -q -n thinkpad-%{version}
%patch0 -p1
if test "%{k26}" = "1" ; then
  # Need to copy the source tree for 2.6
  cp -pR %{ksrc} linux-%{kernel}
  cd linux-%{kernel}
  cp -p %{kcfg} .config
  # Hack to avoid building the whole kernel
  %{__perl} -pi -e 's/^modules:.*$/modules: \$(SUBDIRS)/' Makefile
  # Strip "custom" suffix from Makefile if applicable
  if ! echo %{kernel} | grep 'custom$' ; then
    %{__perl} -pi -e 's/^(\s*EXTRAVERSION.+)custom\s*$/$1/' Makefile
  fi
  cd -
fi


%build
make %{?_smp_mflags} all \
 KVERS=%{kernel} \
%if %{k26}
 KSRC=`pwd`/linux-%{kernel}
%else
 KSRC=%{ksrc} \
 CC="%(%kmh -- cc)" \
 KCFLAGS="%(%kmh -- allcflags)"
%endif


%install
rm -rf $RPM_BUILD_ROOT
make install_modules \
  KVERS=%{kernel} \
  DIR_MOD=$RPM_BUILD_ROOT/lib/modules \
  DIR_MOD_VER=$RPM_BUILD_ROOT/lib/modules/%{kernel} \
  DIR_MODULES_VER=$RPM_BUILD_ROOT/lib/modules/%{kernel}
install -Dpm 644 man/thinkpad.4 $RPM_BUILD_ROOT%{_mandir}/man4/thinkpad.4
install -Dpm 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d/thinkpad

/dev/MAKEDEV -M \
  -c $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d \
  -d $RPM_BUILD_ROOT/dev thinkpad | sed "s|$RPM_BUILD_ROOT||g" > devices.list


%clean
rm -rf $RPM_BUILD_ROOT


%pre %{kernel}
groupadd -r thinkpad >/dev/null 2>&1 || :

%post %{kernel}
depmod -ae -F /boot/System.map-%{kernel} %{kernel} >/dev/null || :

%postun %{kernel}
depmod -ae -F /boot/System.map-%{kernel} %{kernel} >/dev/null || :


%files %{kernel} -f devices.list
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README SUPPORTED-MODELS TECHNOTES
%config %{_sysconfdir}/makedev.d
/lib/modules/%{kernel}/thinkpad
%{_mandir}/man4/thinkpad.4*


%changelog
* Sun Mar 14 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:5.0-0.fdr.4
- Fix README path in %%description (#503).
- Avoid misleading build error message when no kernel-source is installed.

* Mon Feb  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:5.0-0.fdr.3
- Update to kmodhelper 0.9.8.

* Sat Jan 31 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:5.0-0.fdr.2
- Further spec cleanups, kmodhelper 0.9.7.

* Fri Jan 30 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:5.0-0.fdr.1
- Update to 5.0, and kmodhelper to 0.9.6.
- Use MAKEDEV again.

* Thu Jan  8 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:4.999-0.fdr.0.2.trial1
- Cosmetic specfile changes.

* Sun Dec 28 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.999-0.fdr.0.1.trial1
- Update to 4.999-trial1.
- Experimental, untested support for kernel 2.6.
- New version (0.9.5) of kmodhelper.

* Sat Dec 20 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.8-0.fdr.7
- Honor --target again.
- New version of kmodhelper.

* Fri Dec 19 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.8-0.fdr.6
- Pretty much reworked specfile, it should now be relatively easy to build
  modules for all kernel variants if one so desires.
- Back to providing kernel-module instead of kernel-modules because the
  naming scheme doesn't coexist prettily with up2date's kernel-modules
  behavior.
- Run depmod only if installing/uninstalling modules for the running kernel.

* Sat Dec  6 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.8-0.fdr.5
- Require /boot/vmlinuz-%%{kversion} (bug 503).
- Provide kernel-modules instead of kernel-module (bug 503).
- Build modules with the correct $CC.

* Tue Nov 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.8-0.fdr.4
- Don't use MAKEDEV to create /dev/thinkpad.

* Sat Nov 22 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.8-0.fdr.3
- Use sourceforge.net tarball.

* Sun Nov 16 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.8-0.fdr.2
- Add kernel config location workararound for .nptl kernels.

* Sat Oct 11 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.8-0.fdr.1
- Update to 4.8.
- Include kernel cflags scripts in the package.

* Tue Jul 29 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.6-0.fdr.2
- Nuke reference to README.modules.conf in %%description (bug 503).
- Use fedora-rpm-helper.

* Thu Jul 24 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.6-0.fdr.1
- Update to 4.6.
- Drop README.modules.conf; upstream README has the necessary info.

* Sat May 17 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.4-0.fdr.1
- Update to 4.4 (from Debian).
- Un-hardwire 2.4.x build.
- Use proper kernel CFLAGS.
- Require specific kernel version.
- Use /dev/MAKEDEV for creating the device node, and own it.
- %%{buildroot} -> $RPM_BUILD_ROOT.
- Post(un)install scriptlet cleanups.

* Fri Apr 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.4
- Actually build for a 2.4.x kernel, hardwired for now (#214).

* Mon Apr 21 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.3
- Rename to kernel-module-thinkpad.
- Obsolete kernel-mod-thinkpad.
- Add ExclusiveArch: i586 i686.
- Fix missing epoch in kernel-source dependency.

* Mon Apr  7 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.2
- Actually include README.modules.conf (#8 comment 13).

* Sat Apr  5 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.1
- Update to 4.3.
- More spec file cleanups.

* Mon Mar 31 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.7-0.fdr.3
- Small spec cleanups.

* Sun Mar 30 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.7-0.fdr.2
- %%postun tricks for better cleanup after erase.

* Thu Mar 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.7-0.fdr.1
- Updated according to Fedora naming guidelines RC3.

* Sun Feb 23 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.4
- Proof-of-concept for new kernel module packaging guideline proposal.
- Create group and /dev/thinkpad only on new install.
- Renamed to thinkpad-kernel.

* Sun Feb 23 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.3
- Do install_modules instead of install in %%install to avoid unnecessary
  modprobing (#8).

* Sat Feb 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.2
- Add support for %%kernel define.

* Sat Feb  8 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.1
- First Fedora release.
